#ifndef XS_TEST_CONFIG_H_INCLUDED
#define XS_TEST_CONFIG_H_INCLUDED

#include <deque>
#include <memory>

#include <boost/filesystem.hpp>
#include <nlohmann/json.hpp>

#include "test/Service.h"


namespace xs { namespace test
{
    class Config final
    {
    public:
        Config() = delete;
        explicit Config(const boost::filesystem::path& file);
        Config(const Config&) = delete;
        Config(Config&&) = delete;
        ~Config() noexcept = default;

        Config& operator=(const Config&) = delete;
        Config& operator=(Config&&) = delete;

    private:
        static bool verify(const nlohmann::json& object) noexcept;

    public:
        std::deque<Service> services_;
    };
} }

#endif
